from django.db.backends.sqlite3.base import \
    DatabaseError, \
    IntegrityError, \
    DatabaseFeatures, \
    DatabaseOperations, \
    DatabaseWrapper as BaseDatabaseWrapper
from quickwiki.lib.base import Session

class Cursor(object):
    def __init__(self, cursor):
        self.cursor = cursor
    
    def __getattr__(self, name):
        return getattr(self.cursor, name)
    
    def execute(self, sql, params, *args, **kwargs):
        sql = sql % (('?',) * len(params))
        return self.cursor.execute(sql, params, *args, **kwargs)

class DatabaseWrapper(BaseDatabaseWrapper):
    def _cursor(self, settings):
        self.connection = Session.connection().connection
        return Cursor(self.connection.cursor())
    
    def _rollback(self):
        Session.rollback()
    
    def _commit(self):
        Session.commit()
    
    def close(self):
        Session.close()
        self.connection = None
